Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2819)
@@ -21,81 +21,79 @@
    PUBLIC   trc_alloc   ! called by nemogcm.F90
 
-   !! passive tracers names and units (read in namelist)
-   !! --------------------------------------------------
-   CHARACTER(len=12), PUBLIC, DIMENSION(jptra) ::   ctrcnm     !: tracer name 
-   CHARACTER(len=12), PUBLIC, DIMENSION(jptra) ::   ctrcun     !: tracer unit
-   CHARACTER(len=80), PUBLIC, DIMENSION(jptra) ::   ctrcnl     !: tracer long name 
-   
-   
    !! parameters for the control of passive tracers
    !! --------------------------------------------------
-   INTEGER, PUBLIC                   ::   numnat   !: the number of the passive tracer NAMELIST
-   LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutini   !:  initialisation from FILE or not (NAMELIST)
-   LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutsav   !:  save the tracer or not
+   INTEGER, PUBLIC                                                 ::   numnat        !: the number of the passive tracer NAMELIST
 
    !! passive tracers fields (before,now,after)
    !! --------------------------------------------------
-   REAL(wp), PUBLIC ::   trai                          !: initial total tracer
-   REAL(wp), PUBLIC ::   areatot                       !: total volume 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:)   ::   cvol   !: volume correction -degrad option- 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   trn    !: traceur concentration for now time step
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   tra    !: traceur concentration for next time step
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   trb    !: traceur concentration for before time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)               ::  trai           !: initial total tracer
+   REAL(wp), PUBLIC                                                ::  areatot        !: total volume 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:  )         ::  cvol           !: volume correction -degrad option- 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:)         ::  trn            !: traceur concentration for now time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:)         ::  tra            !: traceur concentration for next time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:)         ::  trb            !: traceur concentration for before time step
 
    !! interpolated gradient
    !!--------------------------------------------------  
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::   gtru   !: hor. gradient at u-points at bottom ocean level
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::   gtrv   !: hor. gradient at v-points at bottom ocean level
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)           ::  gtru           !: hor. gradient at u-points at bottom ocean level
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)           ::  gtrv           !: hor. gradient at v-points at bottom ocean level
    
-   !! passive tracers restart (input and output)
+   !! passive tracers  (input and output)
    !! ------------------------------------------  
-   LOGICAL          , PUBLIC ::  ln_rsttr        !: boolean term for restart i/o for passive tracers (namelist)
-   LOGICAL          , PUBLIC ::  lrst_trc        !: logical to control the trc restart write
-   INTEGER          , PUBLIC ::  nn_dttrc        !: frequency of step on passive tracers
-   INTEGER          , PUBLIC ::  nutwrs          !: output FILE for passive tracers restart
-   INTEGER          , PUBLIC ::  nutrst          !: logical unit for restart FILE for passive tracers
-   INTEGER          , PUBLIC ::  nn_rsttr        !: control of the time step ( 0 or 1 ) for pass. tr.
-   CHARACTER(len=50), PUBLIC ::  cn_trcrst_in    !: suffix of pass. tracer restart name (input)
-   CHARACTER(len=50), PUBLIC ::  cn_trcrst_out   !: suffix of pass. tracer restart name (output)
-   
+   LOGICAL             , PUBLIC                                    ::  ln_rsttr       !: boolean term for restart i/o for passive tracers (namelist)
+   LOGICAL             , PUBLIC                                    ::  lrst_trc       !: logical to control the trc restart write
+   INTEGER             , PUBLIC                                    ::  nn_dttrc       !: frequency of step on passive tracers
+   INTEGER             , PUBLIC                                    ::  nn_writetrc    !: time step frequency for concentration outputs (namelist)
+   INTEGER             , PUBLIC                                    ::  nutwrs         !: output FILE for passive tracers restart
+   INTEGER             , PUBLIC                                    ::  nutrst         !: logical unit for restart FILE for passive tracers
+   INTEGER             , PUBLIC                                    ::  nn_rsttr       !: control of the time step ( 0 or 1 ) for pass. tr.
+   CHARACTER(len = 80) , PUBLIC                                    ::  cn_trcrst_in   !: suffix of pass. tracer restart name (input)
+   CHARACTER(len = 80) , PUBLIC                                    ::  cn_trcrst_out  !: suffix of pass. tracer restart name (output)
+   REAL(wp)            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)   ::  rdttrc         !: vertical profile of passive tracer time step
+   LOGICAL             , PUBLIC                                    ::  ln_trcdta      !: Read inputs data from files
+   LOGICAL             , PUBLIC                                    ::  ln_trcdmp      !: internal damping flag
+
    !! information for outputs
    !! --------------------------------------------------
-   INTEGER , PUBLIC ::   nn_writetrc   !: time step frequency for concentration outputs (namelist)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   rdttrc        !: vertical profile of passive tracer time step
-   
-# if defined key_diatrc && ! defined key_iomput
+   TYPE, PUBLIC :: PTRACER                                                            !: Passive tracer type
+       CHARACTER(len = 20)  :: clsname  !: short name
+       CHARACTER(len = 80)  :: cllname  !: long name
+       CHARACTER(len = 20)  :: clunit   !: unit
+       LOGICAL              :: llinit   !: read in a file or not
+       LOGICAL              :: llsave   !: save the tracer or not
+   END TYPE PTRACER
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ctrcnm         !: tracer name 
+   CHARACTER(len = 80), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ctrcln         !: trccer field long name
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ctrcun         !: tracer unit
+   LOGICAL            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_ini     !: Initialisation from data input file
+   LOGICAL            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_wri     !: save the tracer or not
+
+   TYPE, PUBLIC :: DIAG                                                               !: passive trcacer ddditional diagnostic type
+      CHARACTER(len = 20)  :: sname    !: short name
+      CHARACTER(len = 80)  :: lname    !: long name
+      CHARACTER(len = 20)  :: units    !: unit
+   END TYPE DIAG
+
    !! additional 2D/3D outputs namelist
    !! --------------------------------------------------
-   INTEGER         , PUBLIC                      ::   nn_writedia   !: frequency of additional arrays outputs(namelist)
-   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia2d) ::   ctrc2d      !: 2d output field name
-   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia2d) ::   ctrc2u      !: 2d output field unit   
-   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia3d) ::   ctrc3d      !: 3d output field name
-   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia3d) ::   ctrc3u      !: 3d output field unit
-   CHARACTER(len=80), PUBLIC, DIMENSION(jpdia2d) ::   ctrc2l      !: 2d output field long name
-   CHARACTER(len=80), PUBLIC, DIMENSION(jpdia3d) ::   ctrc3l      !: 3d output field long name
+   REAL(wp)           , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,  :) ::   trc2d         !: additional 2d outputs array 
+   REAL(wp)           , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   trc3d         !: additional 3d outputs array 
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   ctrc2d        !: 2d field short name
+   CHARACTER(len = 80), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   ctrc2l        !: 2d field long name
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   ctrc2u        !: 2d field unit
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   ctrc3d        !: 3d field short name
+   CHARACTER(len = 80), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   ctrc3l        !: 3d field long name
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   ctrc3u        !: 3d field unit
+   LOGICAL            , PUBLIC                                        ::  ln_diatrc      !: boolean term for additional diagnostic
+   INTEGER            , PUBLIC                                        ::  nn_writedia    !: frequency of additional outputs
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,  :) ::   trc2d    !:  additional 2d outputs  
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   trc3d    !:  additional 3d outputs  
-# endif
-
-# if defined key_diabio || defined key_trdmld_trc
-   !                                                              !!*  namtop_XXX namelist *
-   INTEGER , PUBLIC                               ::   nn_writebio   !: time step frequency for biological outputs 
-   CHARACTER(len=8 ), PUBLIC, DIMENSION(jpdiabio) ::   ctrbio      !: biological trends name      
-   CHARACTER(len=20), PUBLIC, DIMENSION(jpdiabio) ::   ctrbiu      !: biological trends unit   
-   CHARACTER(len=80), PUBLIC, DIMENSION(jpdiabio) ::   ctrbil      !: biological trends long name
-# endif
-# if defined key_diabio
    !! Biological trends
    !! -----------------
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   trbio   !: biological trends
-# endif
-
-   
-   !! passive tracers data read and at given time_step
-   !! --------------------------------------------------
-# if defined key_dtatrc
-   INTEGER , PUBLIC, DIMENSION(jptra) ::   numtr   !: logical unit for passive tracers data
-# endif
+   LOGICAL            , PUBLIC                                        ::  ln_diabio      !: boolean term for biological diagnostic
+   INTEGER            , PUBLIC                                        ::  nn_writebio    !: frequency of biological outputs
+   REAL(wp)           , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  trbio          !: biological trends
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::  ctrbio         !: bio field short name
+   CHARACTER(len = 80), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::  ctrbil         !: bio field long name
+   CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::  ctrbiu         !: bio field unit
 
    !!----------------------------------------------------------------------
@@ -113,16 +111,9 @@
       !!-------------------------------------------------------------------
       !
-      ALLOCATE( cvol(jpi,jpj,jpk      ) ,                           &
-         &      trn (jpi,jpj,jpk,jptra) ,                           &
-         &      tra (jpi,jpj,jpk,jptra) ,                           &
-         &      trb (jpi,jpj,jpk,jptra) ,                           &
-         &      gtru(jpi,jpj    ,jptra) , gtrv(jpi,jpj,jptra) ,     &
-# if defined key_diatrc && ! defined key_iomput
-         &      trc2d(jpi,jpj,jpdia2d), trc3d(jpi,jpj,jpk,jpdia3d), &
-# endif
-# if defined key_diabio
-         &      trbio(jpi,jpj,jpk,jpdiabio),                        &
-#endif
-               rdttrc(jpk) ,  STAT=trc_alloc )      
+      ALLOCATE( trn(jpi,jpj,jpk,jptra), trb(jpi,jpj,jpk,jptra), tra(jpi,jpj,jpk,jptra),       &  
+         &      gtru(jpi,jpj,jpk)     , gtrv(jpi,jpj,jpk)                             ,       &
+         &      cvol(jpi,jpj,jpk)     , rdttrc(jpk)           , trai(jptra)           ,       &
+         &      ctrcnm(jptra)         , ctrcln(jptra)         , ctrcun(jptra)         ,       & 
+         &      ln_trc_ini(jptra)     , ln_trc_wri(jptra)                             ,  STAT = trc_alloc  )  
 
       IF( trc_alloc /= 0 )   CALL ctl_warn('trc_alloc: failed to allocate arrays')
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 2819)
@@ -11,5 +11,5 @@
    !!                  !  2008-05 (C. Ethe re-organization)
    !!----------------------------------------------------------------------
-#if defined key_top && ! defined key_iomput
+#if defined key_top 
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
@@ -25,5 +25,7 @@
    USE par_trc
    USE dianam    ! build name of file (routine)
-   USE ioipsl
+   USE ioipsl    ! I/O manager
+   USE iom       ! I/O manager
+   USE lib_mpp   ! MPP library
 
    IMPLICIT NONE
@@ -31,5 +33,4 @@
 
    PUBLIC   trc_dia        ! called by XXX module 
-   PUBLIC   trc_dia_alloc  ! called by nemogcm.F90
 
    INTEGER  ::   nit5      !: id for tracer output file
@@ -41,14 +42,12 @@
    INTEGER , ALLOCATABLE, SAVE, DIMENSION (:) ::   ndext50   !: integer arrays for ocean 3D index
    INTEGER , ALLOCATABLE, SAVE, DIMENSION (:) ::   ndext51   !: integer arrays for ocean surface index
-# if defined key_diatrc
+
    INTEGER  ::   nitd      !: id for additional array output file
    INTEGER  ::   ndepitd   !: id for depth mesh
    INTEGER  ::   nhoritd   !: id for horizontal mesh
-# endif
-# if defined key_diabio
+
    INTEGER  ::   nitb        !:         id.         for additional array output file
    INTEGER  ::   ndepitb   !:  id for depth mesh
    INTEGER  ::   nhoritb   !:  id for horizontal mesh
-# endif
 
    !! * Substitutions
@@ -67,12 +66,21 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time-step
-      !
-      INTEGER ::   kindic   ! local integer
+      INTEGER, INTENT(in) ::   kt             ! ocean time-step
+      !
+      INTEGER             ::  ierr,  kindic   ! local integer
       !!---------------------------------------------------------------------
       !
-      CALL trcdit_wr( kt, kindic )      ! outputs for tracer concentration
-      CALL trcdii_wr( kt, kindic )      ! outputs for additional arrays
-      CALL trcdib_wr( kt, kindic )      ! outputs for biological trends
+      IF( kt == nit000 )  THEN
+         ALLOCATE( ndext50(jpij*jpk), ndext51(jpij), STAT=ierr )
+         IF( ierr > 0 ) THEN
+            CALL ctl_stop( 'STOP', 'trc_diat: unable to allocate arrays' )  ;   RETURN
+         ENDIF
+      ENDIF
+      !
+      IF( .NOT.lk_iomput ) THEN
+                          CALL trcdit_wr( kt, kindic )      ! outputs for tracer concentration
+         IF( ln_diatrc )  CALL trcdii_wr( kt, kindic )      ! outputs for additional arrays
+         IF( ln_diabio )  CALL trcdib_wr( kt, kindic )      ! outputs for biological trends
+      ENDIF
       !
    END SUBROUTINE trc_dia
@@ -145,4 +153,13 @@
       
       IF( kt == nit000 ) THEN
+
+         IF(lwp) THEN                   ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) '    frequency of outputs for passive tracers nn_writetrc = ', nn_writetrc
+            DO jn = 1, jptra
+               IF( ln_trc_wri(jn) )  WRITE(numout,*) ' ouput tracer nb : ', jn, '    short name : ', ctrcnm(jn) 
+            END DO
+            WRITE(numout,*) ' '
+         ENDIF
 
          ! Compute julian date from starting date of the run
@@ -182,7 +199,7 @@
          ! Declare all the output fields as NETCDF variables
          DO jn = 1, jptra
-            IF( lutsav(jn) ) THEN
+            IF( ln_trc_wri(jn) ) THEN
                cltra  = TRIM( ctrcnm(jn) )   ! short title for tracer
-               cltral = TRIM( ctrcnl(jn) )   ! long title for tracer
+               cltral = TRIM( ctrcln(jn) )   ! long title for tracer
                cltrau = TRIM( ctrcun(jn) )   ! UNIT for tracer
                CALL histdef( nit5, cltra, cltral, cltrau, jpi, jpj, nhorit5,  &
@@ -209,5 +226,5 @@
       DO jn = 1, jptra
          cltra  = TRIM( ctrcnm(jn) )   ! short title for tracer
-         IF( lutsav(jn) ) CALL histwrite( nit5, cltra, it, trn(:,:,:,jn), ndimt50, ndext50 )
+         IF( ln_trc_wri(jn) ) CALL histwrite( nit5, cltra, it, trn(:,:,:,jn), ndimt50, ndext50 )
       END DO
 
@@ -217,6 +234,4 @@
       !
    END SUBROUTINE trcdit_wr
-
-#if defined key_diatrc
 
    SUBROUTINE trcdii_wr( kt, kindic )
@@ -360,12 +375,4 @@
 
    END SUBROUTINE trcdii_wr
-
-# else
-   SUBROUTINE trcdii_wr( kt, kindic )                      ! Dummy routine
-      INTEGER, INTENT (in) :: kt, kindic
-   END SUBROUTINE trcdii_wr
-# endif
-
-# if defined key_diabio
 
    SUBROUTINE trcdib_wr( kt, kindic )
@@ -485,21 +492,4 @@
    END SUBROUTINE trcdib_wr
 
-# else
-
-   SUBROUTINE trcdib_wr( kt, kindic )                      ! Dummy routine
-      INTEGER, INTENT ( in ) ::   kt, kindic
-   END SUBROUTINE trcdib_wr
-
-# endif 
-
-   INTEGER FUNCTION trc_dia_alloc()
-      !!---------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_dia_alloc  ***
-      !!---------------------------------------------------------------------
-      ALLOCATE( ndext50(jpij*jpk), ndext51(jpij), STAT=trc_dia_alloc )
-      !
-      IF( trc_dia_alloc /= 0 )   CALL ctl_warn('trc_dia_alloc : failed to allocate arrays')
-      !
-   END FUNCTION trc_dia_alloc
 #else
    !!----------------------------------------------------------------------
